
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <sys/time.h>
#include <time.h>
#include <unistd.h>
#include <sys/types.h>
#include <limits.h>




FILE *fiche;      /* pointeur sur FILE */
char *filo;//[50]; /* nom du fichier */

//#define SORTIE "OUTPUT.txt"

#define MAX_CLAUSES 10000
#define MAX_VARS    10000
#define MAX_TPOP    5000
#define MILLI_S 1000.0
#define MICRO_S 1000000.0
#define NANO_S 1000000000.0
#define PICO_S 1000000000000.0

#define WALK 0.3
#define WALK1 0.6

#define max_sol   4

float WP;


/*FILE  *f_in;*/
FILE  *f_out;

FILE  *f_res;
FILE  *f_res1;

#define BIG 0777771
int             rand();


int seed;


typedef struct data *data_p;

struct data {
     int          m;
     int          n;
     int          sense;
     data_p       next1;
     data_p       next2;
};


/***********************************************************
/***********************************************************




/*
 * Information about the variables.
 */


data_p           vars[MAX_VARS];

float           AVG[MAX_CLAUSES];
/*float             profit[MAX_CLAUSES];*/
float              som;

double maxiter_begin;
double maxiter_now;

int               CB[MAX_CLAUSES];
int               CB1[MAX_CLAUSES];
int               best_CB[MAX_CLAUSES];


int             col_count[MAX_VARS];
int             CON[MAX_CLAUSES][MAX_CLAUSES];
int             NC[MAX_CLAUSES][MAX_CLAUSES];
int             NC_Offre_Profit_Max[MAX_CLAUSES];




int               m1,n1;
int		          maxit;



 /* Information about the clauses.*/

int             row_count[MAX_CLAUSES];
int          matrice_nb_sense[MAX_VARS][2];
int             sol[MAX_VARS];
int             sol1[MAX_VARS];
int             sol_max_sense[MAX_VARS];
int             c_cour;
int             best_soln[MAX_VARS];
int             best_c_cour;
int             best_best_c_cour;
int             num_improve[MAX_VARS];
int             num_improve1[MAX_VARS];
int             best_list[MAX_VARS];
int             best_list1[MAX_CLAUSES];
int             best_count;
int             best_improve;
int             col_count[MAX_VARS];
int             max_iter;
int             sat_count[MAX_CLAUSES];


/*
 * Information about the clauses.
 */
data_p      clauses[MAX_CLAUSES];
int             row_count[MAX_CLAUSES];





/*
 * Information �propos de l'HH.
 */

int nb_HBN = 7;
typedef struct
{
    double  performance_calcul;
    double  temps_attente;
}struct_matr_HBN;




int heuristique_courrant, heuristique_precedent;
typedef void (*Tfonc)(void); // Type pointeur de fonction.

float alpha=0.9;
float beta=0.1;
float gama=1.5;
float             TM1=0.152; //0.152 best
float             TM2=0.071;  // plus ou moins de bon r�ultat avec 0.09, 0.08. de bon r�ultat avec 0.071

Tfonc liste_HBN[7];
struct_matr_HBN matrice_HBN[7][7];


typedef struct
{
  int num_offre;
  float score;

}table_struct_offre_score;

typedef struct {
  time_t tv_sec;
  long   tv_usec;
  long   tv_nsec;
} timeval;



void local(void);





/*****         Error  Function               ************/
/********************************************************/

void erreur(char *error_text)
{
  fprintf(stderr,"\n\n",error_text);
  fprintf(stderr, "now exiting to system ....,\n");

}



/**********************************/

/*
 * Read in the problem.
 */

void read_prob(filename)
     char           *filename;
{
     FILE           *fp;
     char            line[100];
     char            tempstr1[10];
     char            tempstr2[10];
     int             temp;
     int             i;
     data_p       p;




if ((f_res1 = fopen(filename,"r")) == NULL)
    {
      fprintf(stderr, "\nErreur: Impossible de lire le fichier %s\n",filename);
      //return(EXIT_FAILURE);
    }

     fgets(line, 100, f_res1);

     while (line[0] != 'p') {
	  fgets(line, 100, f_res1);
     };


     sscanf(line, "%s %s %d %d", tempstr1, tempstr2, &n1, &m1);


   for (i = 0; i < n1; i++) {
	  vars[i] = (data_p) NULL;
	  col_count[i] = 0;
	  matrice_nb_sense[i][0]=0;
	  matrice_nb_sense[i][1]=0;
     };
     for (i = 0; i < m1; i++) {
	  clauses[i] = (data_p) NULL;
	  row_count[i] = 0;
     };



     for (i = 0; i <= m1 - 1; i++) {
	  fscanf(f_res1, "%d", &temp);


	  while (temp != 0) {

	    p=clauses[i];
	    while (p != (data_p) NULL)
	      {
		if (p->n == abs(temp)-1)
		  {
		    if ((p->sense == 1) && (temp > 0))
		      goto NEXT_LITERAL;
		    if ((p->sense == 0) && (temp < 0))
		      goto NEXT_LITERAL;
		  };
		p=p->next2;
	      };




	       /*
	        * Allocate an data for this literal.
	        */

	       p = (data_p) malloc(sizeof(struct data));
	       p->m = i;
	       p->n = abs(temp) - 1;
	       col_count[p->n] = col_count[p->n] + 1;
	       if (temp > 0) {
		    p->sense = 1;

matrice_nb_sense[abs(temp) - 1][1]=matrice_nb_sense[abs(temp) - 1][1]+1;
	       } else {
		    p->sense = 0;
		    matrice_nb_sense[abs(temp) - 1][0]=matrice_nb_sense[abs(temp) - 1][0]+1;

	       };


	       /*
	        * Now, link it into the data structure.
	        */


	       p->next2 = clauses[i];
	       clauses[i] = p;
	       row_count[i] = row_count[i] + 1;

	       p->next1 = vars[p->n];
	       vars[p->n] = p;

	       /*
	        * Finally, get the next number out of the file.
	        */

	  NEXT_LITERAL:
	       fscanf(f_res1, "%d", &temp);
	  };
     };

}


/**********************************/

void construct_Sol_Max_sense(void)
{
int i;

for(i=0;i<n1;i++)
{
    if(matrice_nb_sense[i][0]>matrice_nb_sense[i][1])
            sol_max_sense[i]=0;
    else
            sol_max_sense[i]=1;

}
}

/**********************************/

void init_sol(void)
{

double r;
data_p p;

int j, i, sense, clause, var;


for (j = 0; j < n1 ; j++)
    {
	  r = (rand() % (RAND_MAX + 1)) / ((float) RAND_MAX);
	  if (r > 0.5)
	  {
	       sol[j] = 0;
	  }
	  else
	  {
	       sol[j] = 1;
      }
    }



    c_cour = 0;
     for (j = 0; j < m1; j++)
     {
	  p = clauses[j];
	  sat_count[j] = 0;
	  while (p != ((data_p) NULL)) {
	       var = p->n;
	       if (sol[var] == 1) {
		    if (p->sense == 1) {
			 sat_count[j] = sat_count[j] + 1;
		    };
	       } else {
		    if (p->sense == 0) {
			 sat_count[j] = sat_count[j] + 1;
		    };
	       };
	       p = p->next2;
	  };
	  if (sat_count[j] > 0)
        {
	       c_cour++;
	    };
     }


/**********************************/

for (j = 0; j < n1; j++)
    {
	  num_improve[j] = 0;
	  p = vars[j];
	  while (p != ((data_p) NULL)) {
	       var = p->n;
	       clause = p->m;
	       sense = p->sense;
	       switch (sat_count[clause]) {
	       case 0:
		    if ((sense == 1) && (sol[j] == 0)) {
			 num_improve[j] = num_improve[j] + 1;
		    };
		    if ((sense == 0) && (sol[j] == 1)) {
			 num_improve[j] = num_improve[j] + 1;
		    };
		    break;
	       case 1:
		    if ((sense == 1) && (sol[j] == 1)) {
			 num_improve[j] = num_improve[j] - 1;
		    };
		    if ((sense == 0) && (sol[j] == 0)) {
			 num_improve[j] = num_improve[j] - 1;
		    };
		    break;
	       };
	       p = p->next1;
	  };
     }

/**********************************/

if(c_cour>best_c_cour)
{
    for(i=0;i<n1;i++) best_soln[i]=sol[i];
    best_c_cour=c_cour;
}

construct_Sol_Max_sense();

}

/**********************************/


void heuristic_H1(void)
{



int i, j, clause, var, sense, flipvar, count_num_improve;
data_p p, p2;


for(i=0;i<n1; i++)
{
    sol[i]=best_soln[i];
}


    c_cour = 0;
     for (j = 0; j < m1; j++)
     {
	  p = clauses[j];
	  sat_count[j] = 0;
	  while (p != ((data_p) NULL)) {
	       var = p->n;
	       if (sol[var] == 1) {
		    if (p->sense == 1) {
			 sat_count[j] = sat_count[j] + 1;
		    };
	       } else {
		    if (p->sense == 0) {
			 sat_count[j] = sat_count[j] + 1;
		    };
	       };
	       p = p->next2;
	  };
	  if (sat_count[j] > 0)
              {
	       c_cour++;
	      };
     }


count_num_improve=0;

for (j = 0; j < n1; j++)
    {
	  num_improve[j] = 0;
	  p = vars[j];
	  while (p != ((data_p) NULL)) {
	       var = p->n;
	       clause = p->m;
	       sense = p->sense;
	       switch (sat_count[clause]) {
	       case 0:
		    if ((sense == 1) && (sol[j] == 0)) {
			 num_improve[j] = num_improve[j] + 1;
		    };
		    if ((sense == 0) && (sol[j] == 1)) {
			 num_improve[j] = num_improve[j] + 1;
		    };
		    break;
	       case 1:
		    if ((sense == 1) && (sol[j] == 1)) {
			 num_improve[j] = num_improve[j] - 1;
		    };
		    if ((sense == 0) && (sol[j] == 0)) {
			 num_improve[j] = num_improve[j] - 1;
		    };
		    break;
	       };
	       p = p->next1;
	  };
	  if(num_improve[j]>0) count_num_improve++;

     }

flipvar = rand() % n1;
p=vars[flipvar];
if(sol[flipvar]==1 && matrice_nb_sense[flipvar][0]> matrice_nb_sense[flipvar][1] && p->sense==0) sol[flipvar]=0;
else if(sol[flipvar]==0 && matrice_nb_sense[flipvar][0]< matrice_nb_sense[flipvar][1] && p->sense==1) sol[flipvar]=1;
     else if(count_num_improve>0)
            {
                i=0;
                j=-1;
                flipvar=rand()%count_num_improve;
                do
                {
                    j++;
                    if(j==flipvar)
                    {
                        sol[i]=1-sol[i];
                    }
                    i++;
                }while(i<n1 && j<flipvar);
            }
            else
            {
                flipvar=rand()%n1;
                sol[flipvar] = 1 - sol[flipvar];
            }


/**********************************/

          c_cour = c_cour + num_improve[flipvar];


          num_improve[flipvar] = -num_improve[flipvar];

	  p = vars[flipvar];

         while (p != ((data_p) NULL))
             {
	       var = p->n;
	       clause = p->m;
	       sense = p->sense;

	       if (sense == 1) {
		    if (sol[flipvar] == 1)
                        {
			 sat_count[clause] = sat_count[clause] + 1;
			 if (sat_count[clause] == 1)
                         {
			      p2 = clauses[clause];
			      while (p2 != ((data_p) NULL)) {
				   if (p2->n != flipvar) {
					num_improve[p2->n] =
					     num_improve[p2->n] - 1;
				   };
				   p2 = p2->next2;
			      };
			 };

                           if (sat_count[clause] == 2) {
			      p2 = clauses[clause];
			      while (p2 != ((data_p) NULL)) {
				   if ((p2->sense == sol[p2->n]) &&
				       (p2->n != flipvar)) {
			num_improve[p2->n] = num_improve[p2->n] + 1;
					break;
				   };

				   p2 = p2->next2;
			      };
			 };
		    } else
                          {

                           sat_count[clause] = sat_count[clause] - 1;

			 if (sat_count[clause] == 0) {
			      p2 = clauses[clause];
			      while (p2 != ((data_p) NULL)) {
				   if (p2->n != flipvar) {
	num_improve[p2->n] = num_improve[p2->n] +1;
				   };
				   p2 = p2->next2;
			      };
			 };

                         if (sat_count[clause] == 1) {
			      p2 = clauses[clause];
			      while (p2 != ((data_p) NULL)) {
				   if (p2->sense == sol[p2->n]) {
			num_improve[p2->n] = num_improve[p2->n] -1;
					break;
				   };
				   p2 = p2->next2;
			      };
			 };
		    };
	       } else {
		    if (sol[flipvar] == 1) {

			 sat_count[clause] = sat_count[clause] - 1;
			 if (sat_count[clause] == 0) {
			      p2 = clauses[clause];
			      while (p2 != ((data_p) NULL)) {
				   if (p2->n != flipvar) {
			num_improve[p2->n] = num_improve[p2->n] +1;
				   };
				   p2 = p2->next2;
			      };
			 };

			 if (sat_count[clause] == 1) {
			      p2 = clauses[clause];
			      while (p2 != ((data_p) NULL)) {
				   if (p2->sense == sol[p2->n]) {
			num_improve[p2->n] = num_improve[p2->n] -1;
					break;
				   };
				   p2 = p2->next2;
			      };
			 };
		    } else
                        {

			 sat_count[clause] = sat_count[clause] + 1;

			 if (sat_count[clause] == 1) {
			      p2 = clauses[clause];
			      while (p2 != ((data_p) NULL)) {
				   if (p2->n != flipvar) {
			num_improve[p2->n] = num_improve[p2->n] -1;
				   };
				   p2 = p2->next2;
			      };
			 };

			 if (sat_count[clause] == 2) {
			      p2 = clauses[clause];
			      while (p2 != ((data_p) NULL)) {
				   if ((p2->sense == sol[p2->n]) &&
				       (p2->n != flipvar)) {
			num_improve[p2->n] = num_improve[p2->n] +1;
					break;
				   };
				   p2 = p2->next2;
			      };
			 };

		    };
	       };
	        p = p->next1;

	  };

	  local();
}



void neighboor_H2(void)
{
int j, l, clause, sense, var;
    double r1;
    data_p p;

    for(l=0;l<n1;l++)
    {
        r1= (rand() % (RAND_MAX + 1)) / ((float) RAND_MAX);
        if(r1 > 0.5) {sol[l]=best_soln[l];}
        else {sol[l]=sol1[l];}
    }


    c_cour = 0;
     for (j = 0; j < m1; j++)
     {
	  p = clauses[j];
	  sat_count[j] = 0;
	  while (p != ((data_p) NULL)) {
	       var = p->n;
	       if (sol[var] == 1) {
		    if (p->sense == 1) {
			 sat_count[j] = sat_count[j] + 1;
		    };
	       } else {
		    if (p->sense == 0) {
			 sat_count[j] = sat_count[j] + 1;
		    };
	       };
	       p = p->next2;
	  };
	  if (sat_count[j] > 0)
              {
	       c_cour++;
	      };
     }



for (j = 0; j < n1; j++)
    {
	  num_improve[j] = 0;
	  p = vars[j];
	  while (p != ((data_p) NULL)) {
	       var = p->n;
	       clause = p->m;
	       sense = p->sense;
	       switch (sat_count[clause]) {
	       case 0:
		    if ((sense == 1) && (sol[j] == 0)) {
			 num_improve[j] = num_improve[j] + 1;
		    };
		    if ((sense == 0) && (sol[j] == 1)) {
			 num_improve[j] = num_improve[j] + 1;
		    };
		    break;
	       case 1:
		    if ((sense == 1) && (sol[j] == 1)) {
			 num_improve[j] = num_improve[j] - 1;
		    };
		    if ((sense == 0) && (sol[j] == 0)) {
			 num_improve[j] = num_improve[j] - 1;
		    };
		    break;
	       };
	       p = p->next1;
	  };
     }
}


void heuristic_H2(void)
{

int i,flipvar;

  for(i=0;i<n1;i++)
    {
        sol1[i]=sol_max_sense[i];
    }


    flipvar=rand()%n1;
    sol1[flipvar]=1-sol1[flipvar];

  neighboor_H2();

local();
}

/**********************************/

void heuristic_H7(void)

{
    int k, j, flipvar, sense, var, clause, cl, max_k, max;
data_p p;

    for(k=0;k<n1;k++)
        sol[k]=best_soln[k];

c_cour = 0;
     for (j = 0; j < m1; j++)
     {
	  p = clauses[j];
	  sat_count[j] = 0;
	  while (p != ((data_p) NULL)) {
	       var = p->n;
	       if (sol[var] == 1) {
		    if (p->sense == 1) {
			 sat_count[j] = sat_count[j] + 1;
		    };
	       } else {
		    if (p->sense == 0) {
			 sat_count[j] = sat_count[j] + 1;
		    };
	       };
	       p = p->next2;
	  };
	  if (sat_count[j] > 0)
              {
	       c_cour++;
	      };
     }

max=-MAX_VARS;
max_k=0;
    for (j = 0; j < n1; j++)
    {
	  num_improve[j] = 0;
	  p = vars[j];
	  while (p != ((data_p) NULL)) {
	       var = p->n;
	       clause = p->m;
	       sense = p->sense;
	       switch (sat_count[clause]) {
	       case 0:
		    if ((sense == 1) && (sol[j] == 0)) {
			 num_improve[j] = num_improve[j] + 1;
		    };
		    if ((sense == 0) && (sol[j] == 1)) {
			 num_improve[j] = num_improve[j] + 1;
		    };
		    break;
	       case 1:
		    if ((sense == 1) && (sol[j] == 1)) {
			 num_improve[j] = num_improve[j] - 1;
		    };
		    if ((sense == 0) && (sol[j] == 0)) {
			 num_improve[j] = num_improve[j] - 1;
		    };
		    break;
	       };
	       p = p->next1;
	  };
	  if(num_improve[j]>max)
	  {
	      if((matrice_nb_sense[j][0]>matrice_nb_sense[j][1] && sol[j]==0) ||(matrice_nb_sense[j][0]<=matrice_nb_sense[j][1] && sol[j]==1)) max_k=j;
	  }
     }

     sol[max_k]=1-sol[max_k];

     c_cour = 0;
     for (j = 0; j < m1; j++)
     {
	  p = clauses[j];
	  sat_count[j] = 0;
	  while (p != ((data_p) NULL)) {
	       var = p->n;
	       if (sol[var] == 1) {
		    if (p->sense == 1) {
			 sat_count[j] = sat_count[j] + 1;
		    };
	       } else {
		    if (p->sense == 0) {
			 sat_count[j] = sat_count[j] + 1;
		    };
	       };
	       p = p->next2;
	  };
	  if (sat_count[j] > 0)
              {
	       c_cour++;
	      };
     }
     for (j = 0; j < n1; j++)
    {
	  num_improve[j] = 0;
	  p = vars[j];
	  while (p != ((data_p) NULL)) {
	       var = p->n;
	       clause = p->m;
	       sense = p->sense;
	       switch (sat_count[clause]) {
	       case 0:
		    if ((sense == 1) && (sol[j] == 0)) {
			 num_improve[j] = num_improve[j] + 1;
		    };
		    if ((sense == 0) && (sol[j] == 1)) {
			 num_improve[j] = num_improve[j] + 1;
		    };
		    break;
	       case 1:
		    if ((sense == 1) && (sol[j] == 1)) {
			 num_improve[j] = num_improve[j] - 1;
		    };
		    if ((sense == 0) && (sol[j] == 0)) {
			 num_improve[j] = num_improve[j] - 1;
		    };
		    break;
	       };
	       p = p->next1;
	  };
    }
    local();
}


/**********************************/

void heuristic_H3(void)
{
   int k, flipvar, sense, var, clause, cl;
    double r;
    data_p p, p2;
      int j;


for(k=0;k<n1;k++)
    sol[k]=best_soln[k];

    r= (rand() % (RAND_MAX + 1)) / ((float) RAND_MAX);
           if ( r < WALK)
           {
             flipvar = rand() % n1;
            }
           else
            if ( r < WALK1)
            {
                best_count = 0;
                for (k = 0; k < m1; k++)
                {
                  if (sat_count[k] == 0)
                  {
                        best_count++;
                        best_list1[best_count] = k;
                  };
                };
                cl = best_list1[1 + (MAX_CLAUSES % best_count)];

                best_improve = -MAX_CLAUSES;
                p = clauses[cl];
                while (p != ((data_p) NULL))
                {
                    var = p->n;
                    if (num_improve[var] > best_improve)
                    {
                        best_improve=num_improve[var];

                        flipvar=var;





                    }
                    p = p->next2;
                };
            }
            else

             {



                best_improve = -MAX_CLAUSES;
                best_count = 0;


                for (k = 0; k < n1; k++)
                    {
                        if (num_improve[k] > best_improve)
                        {
                            best_improve = num_improve[k];
                            best_count = 0;
                        };
                        if (num_improve[k] == best_improve)
                        {
                            best_count++;
                            best_list[best_count] = k;
                        };

                    };


                flipvar = best_list[1 + (n1 % best_count)];


             };


sol[flipvar]=1-sol[flipvar];

/**********************************/


      c_cour = 0;
     for (j = 0; j < m1; j++)
     {
	  p = clauses[j];
	  sat_count[j] = 0;
	  while (p != ((data_p) NULL)) {
	       var = p->n;
	       if (sol[var] == 1) {
		    if (p->sense == 1) {
			 sat_count[j] = sat_count[j] + 1;
		    };
	       } else {
		    if (p->sense == 0) {
			 sat_count[j] = sat_count[j] + 1;
		    };
	       };
	       p = p->next2;
	  };
	  if (sat_count[j] > 0)
              {
	       c_cour++;
	      };
     }

/**********************************/

for (j = 0; j < n1; j++)
    {
	  num_improve[j] = 0;
	  p = vars[j];
	  while (p != ((data_p) NULL)) {
	       var = p->n;
	       clause = p->m;
	       sense = p->sense;
	       switch (sat_count[clause]) {
	       case 0:
		    if ((sense == 1) && (sol[j] == 0)) {
			 num_improve[j] = num_improve[j] + 1;
		    };
		    if ((sense == 0) && (sol[j] == 1)) {
			 num_improve[j] = num_improve[j] + 1;
		    };
		    break;
	       case 1:
		    if ((sense == 1) && (sol[j] == 1)) {
			 num_improve[j] = num_improve[j] - 1;
		    };
		    if ((sense == 0) && (sol[j] == 0)) {
			 num_improve[j] = num_improve[j] - 1;
		    };
		    break;
	       };
	       p = p->next1;
	  };
     }

}

/**********************************/

void heuristic_H4(void)
{

int l, j, flipvar, sense, var, clause;
double r1;
data_p p;

for(l=0;l<n1;l++)
    sol[l]=best_soln[l];


 r1= (rand() % (RAND_MAX + 1)) / ((float) RAND_MAX);

 if (r1<TM1)
 {
 flipvar = rand() % n1;
 sol[flipvar]=1-sol[flipvar];

c_cour = 0;
     for (j = 0; j < m1; j++)
     {
	  p = clauses[j];
	  sat_count[j] = 0;
	  while (p != ((data_p) NULL)) {
	       var = p->n;
	       if (sol[var] == 1) {
		    if (p->sense == 1) {
			 sat_count[j] = sat_count[j] + 1;
		    };
	       } else {
		    if (p->sense == 0) {
			 sat_count[j] = sat_count[j] + 1;
		    };
	       };
	       p = p->next2;
	  };
	  if (sat_count[j] > 0)
              {
	       c_cour++;
	      };
     }

/**********************************/

for (j = 0; j < n1; j++)
    {
	  num_improve[j] = 0;
	  p = vars[j];
	  while (p != ((data_p) NULL)) {
	       var = p->n;
	       clause = p->m;
	       sense = p->sense;
	       switch (sat_count[clause]) {
	       case 0:
		    if ((sense == 1) && (sol[j] == 0)) {
			 num_improve[j] = num_improve[j] + 1;
		    };
		    if ((sense == 0) && (sol[j] == 1)) {
			 num_improve[j] = num_improve[j] + 1;
		    };
		    break;
	       case 1:
		    if ((sense == 1) && (sol[j] == 1)) {
			 num_improve[j] = num_improve[j] - 1;
		    };
		    if ((sense == 0) && (sol[j] == 0)) {
			 num_improve[j] = num_improve[j] - 1;
		    };
		    break;
	       };
	       p = p->next1;
	  };
     }
}
local();
}

/**********************************/

void heuristic_H6(void)
{

int l, j, flipvar, sense, var, clause;
double r1;
data_p p;

for(l=0;l<n1;l++)
    sol[l]=best_soln[l];


for(l=0;l<n1;l++)
{
    r1= (rand() % (RAND_MAX + 1)) / ((float) RAND_MAX);
    if(r1<TM2)
    {
        flipvar = rand() % n1;
        sol[flipvar]=1-sol[flipvar];
    }

}

c_cour = 0;
     for (j = 0; j < m1; j++)
     {
	  p = clauses[j];
	  sat_count[j] = 0;
	  while (p != ((data_p) NULL)) {
	       var = p->n;
	       if (sol[var] == 1) {
		    if (p->sense == 1) {
			 sat_count[j] = sat_count[j] + 1;
		    };
	       } else {
		    if (p->sense == 0) {
			 sat_count[j] = sat_count[j] + 1;
		    };
	       };
	       p = p->next2;
	  };
	  if (sat_count[j] > 0)
              {
	       c_cour++;
	      };
     }

/**********************************/

for (j = 0; j < n1; j++)
    {
	  num_improve[j] = 0;
	  p = vars[j];
	  while (p != ((data_p) NULL)) {
	       var = p->n;
	       clause = p->m;
	       sense = p->sense;
	       switch (sat_count[clause]) {
	       case 0:
		    if ((sense == 1) && (sol[j] == 0)) {
			 num_improve[j] = num_improve[j] + 1;
		    };
		    if ((sense == 0) && (sol[j] == 1)) {
			 num_improve[j] = num_improve[j] + 1;
		    };
		    break;
	       case 1:
		    if ((sense == 1) && (sol[j] == 1)) {
			 num_improve[j] = num_improve[j] - 1;
		    };
		    if ((sense == 0) && (sol[j] == 0)) {
			 num_improve[j] = num_improve[j] - 1;
		    };
		    break;
	       };
	       p = p->next1;
	  };
     }

local();
}


/**********************************/
void local(void)
{
    int k, flipvar, sense, var, clause, cl;
    double r;
    data_p p;
   int j;

    r= (rand() % (RAND_MAX + 1)) / ((float) RAND_MAX);
           if ( r < WALK)
           {
             flipvar = rand() % n1;
            }
           else
            if ( r < WALK1)
            {
                best_count = 0;
                for (k = 0; k < m1; k++)
                {
                  if (sat_count[k] == 0)
                  {
                        best_count++;
                        best_list1[best_count] = k;
                  };
                };

                cl = best_list1[1 + (MAX_CLAUSES % best_count)];

                best_improve = -MAX_CLAUSES;
                p = clauses[cl];
                while (p != ((data_p) NULL))
                {
                    var = p->n;
                    if (num_improve[var] > best_improve)
                    {
                        best_improve=num_improve[var];
                        flipvar=var;

                   }
                    p = p->next2;
                };
            }
            else
             {



                best_improve = -MAX_CLAUSES;
                best_count = 0;


                for (k = 0; k < n1; k++)
                    {
                        if (num_improve[k] > best_improve)
                        {
                            best_improve = num_improve[k];
                            best_count = 0;
                        };
                        if (num_improve[k] == best_improve)
                        {
                            best_count++;
                            best_list[best_count] = k;
                        };

                    };



                flipvar = best_list[1 + (n1 % best_count)];

             };
        sol[flipvar]=1-sol[flipvar];



/******************************/

      c_cour = 0;
     for (j = 0; j < m1; j++)
     {
	  p = clauses[j];
	  sat_count[j] = 0;
	  while (p != ((data_p) NULL)) {
	       var = p->n;
	       if (sol[var] == 1) {
		    if (p->sense == 1) {
			 sat_count[j] = sat_count[j] + 1;
		    };
	       } else {
		    if (p->sense == 0) {
			 sat_count[j] = sat_count[j] + 1;
		    };
	       };
	       p = p->next2;
	  };
	  if (sat_count[j] > 0)
              {
	       c_cour++;
	      };
     }

for (j = 0; j < n1; j++)
    {
	  num_improve[j] = 0;
	  p = vars[j];
	  while (p != ((data_p) NULL)) {
	       var = p->n;
	       clause = p->m;
	       sense = p->sense;
	       switch (sat_count[clause]) {
	       case 0:
		    if ((sense == 1) && (sol[j] == 0)) {
			 num_improve[j] = num_improve[j] + 1;
		    };
		    if ((sense == 0) && (sol[j] == 1)) {
			 num_improve[j] = num_improve[j] + 1;
		    };
		    break;
	       case 1:
		    if ((sense == 1) && (sol[j] == 1)) {
			 num_improve[j] = num_improve[j] - 1;
		    };
		    if ((sense == 0) && (sol[j] == 0)) {
			 num_improve[j] = num_improve[j] - 1;
		    };
		    break;
	       };
	       p = p->next1;
	  };
     }

      /*    c_cour = c_cour + num_improve[flipvar];

          sol[flipvar] = 1 - sol[flipvar];
          num_improve[flipvar] = -num_improve[flipvar];
	  p = vars[flipvar];

         while (p != ((data_p) NULL))
             {
	       var = p->n;
	       clause = p->m;
	       sense = p->sense;

	       if (sense == 1) {
		    if (sol[flipvar] == 1)
                        {
			 sat_count[clause] = sat_count[clause] + 1;
			 if (sat_count[clause] == 1)
                         {
			      p2 = clauses[clause];
			      while (p2 != ((data_p) NULL)) {
				   if (p2->n != flipvar) {
					num_improve[p2->n] =
					     num_improve[p2->n] - 1;
				   };
				   p2 = p2->next2;
			      };
			 };

                           if (sat_count[clause] == 2) {
			      p2 = clauses[clause];
			      while (p2 != ((data_p) NULL)) {
				   if ((p2->sense == sol[p2->n]) &&
				       (p2->n != flipvar)) {
		num_improve[p2->n] = num_improve[p2->n] + 1;
					break;
				   };

				   p2 = p2->next2;
			      };
			 };
		    } else
                          {

                           sat_count[clause] = sat_count[clause] - 1;

			 if (sat_count[clause] == 0) {
			      p2 = clauses[clause];
			      while (p2 != ((data_p) NULL)) {
				   if (p2->n != flipvar) {
		num_improve[p2->n] = num_improve[p2->n] +1;
				   };
				   p2 = p2->next2;
			      };
			 };

                         if (sat_count[clause] == 1) {
			      p2 = clauses[clause];
			      while (p2 != ((data_p) NULL)) {
				   if (p2->sense == sol[p2->n]) {
		num_improve[p2->n] = num_improve[p2->n] -1;
					break;
				   };
				   p2 = p2->next2;
			      };
			 };
		    };
	       } else {
		    if (sol[flipvar] == 1) {

			 sat_count[clause] = sat_count[clause] - 1;
			 if (sat_count[clause] == 0) {
			      p2 = clauses[clause];
			      while (p2 != ((data_p) NULL)) {
				   if (p2->n != flipvar) {
		num_improve[p2->n] = num_improve[p2->n] +1;
				   };
				   p2 = p2->next2;
			      };
			 };

			 if (sat_count[clause] == 1) {
			      p2 = clauses[clause];
			      while (p2 != ((data_p) NULL)) {
				   if (p2->sense == sol[p2->n]) {
		num_improve[p2->n] = num_improve[p2->n] -1;
					break;
				   };
				   p2 = p2->next2;
			      };
			 };
		    } else
                        {

			 sat_count[clause] = sat_count[clause] + 1;

			 if (sat_count[clause] == 1) {
			      p2 = clauses[clause];
			      while (p2 != ((data_p) NULL)) {
				   if (p2->n != flipvar) {
	num_improve[p2->n] = num_improve[p2->n] -1;
				   };
				   p2 = p2->next2;
			      };
			 };

			 if (sat_count[clause] == 2) {
			      p2 = clauses[clause];
			      while (p2 != ((data_p) NULL)) {
				   if ((p2->sense == sol[p2->n]) &&
				       (p2->n != flipvar)) {
		num_improve[p2->n] = num_improve[p2->n] +1;
					break;
				   };
				   p2 = p2->next2;
			      };
			 };

		    };
	       };
	        p = p->next1;

	  };*/

}

/************************************************************/
void neighboor_H5(void)
{
    int j, l, clause, sense, var;
    double r1;
    data_p p;

    for(l=0;l<n1;l++)
    {
        r1=rand();
        r1=r1/RAND_MAX;
        if(r1 > 0.5) {sol[l]=best_soln[l];}
        else {sol[l]=sol1[l];}
    }



    c_cour = 0;
     for (j = 0; j < m1; j++)
     {
	  p = clauses[j];
	  sat_count[j] = 0;
	  while (p != ((data_p) NULL)) {
	       var = p->n;
	       if (sol[var] == 1) {
		    if (p->sense == 1) {
			 sat_count[j] = sat_count[j] + 1;
		    };
	       } else {
		    if (p->sense == 0) {
			 sat_count[j] = sat_count[j] + 1;
		    };
	       };
	       p = p->next2;
	  };
	  if (sat_count[j] > 0)
              {
	       c_cour++;
	      };
     }
/*-------------------------------------------------------------------*/

for (j = 0; j < n1; j++)
    {
	  num_improve[j] = 0;
	  p = vars[j];
	  while (p != ((data_p) NULL)) {
	       var = p->n;
	       clause = p->m;
	       sense = p->sense;
	       switch (sat_count[clause]) {
	       case 0:
		    if ((sense == 1) && (sol[j] == 0)) {
			 num_improve[j] = num_improve[j] + 1;
		    };
		    if ((sense == 0) && (sol[j] == 1)) {
			 num_improve[j] = num_improve[j] + 1;
		    };
		    break;
	       case 1:
		    if ((sense == 1) && (sol[j] == 1)) {
			 num_improve[j] = num_improve[j] - 1;
		    };
		    if ((sense == 0) && (sol[j] == 0)) {
			 num_improve[j] = num_improve[j] - 1;
		    };
		    break;
	       };
	       p = p->next1;
	  };
     }
}


void heuristic_H5(void)
{

int j, flipvar, clause, sense, var;
double r;
data_p p, p2;

for (j = 0; j < n1 ; j++)
    {
	  r = (rand() % (RAND_MAX + 1)) / ((float) RAND_MAX);
	  if (r > 0.4)
	  {
	       sol1[j] = 0;
	  }
	  else {
	           sol1[j] = 1;
           }
    }

  neighboor_H5();

local();

}


/***************************************************/

void Construire_Tableau_HBN()
{
}

/***************************************************/

int Choisir_Heuristique(int i)
{

FILE *pf=NULL;

    int j;

    int heuristique_de_bas_niveau=0;

    double temp_score=0.0;

    double max_score=0.0;

 if(i==0)

    {
        heuristique_de_bas_niveau = rand() % nb_HBN;
        return heuristique_de_bas_niveau;
    }




  max_score = (alpha * matrice_HBN[0][0].performance_calcul) + ( beta * matrice_HBN[heuristique_courrant][0].performance_calcul) + ( gama *
matrice_HBN[0][0].temps_attente);

    for(j=1;j<nb_HBN;j++)
    {
        temp_score=0.0;

  if(j!=heuristique_courrant) temp_score = (alpha * matrice_HBN[j][j].performance_calcul) + ( gama * matrice_HBN[j][j].temps_attente);
        else temp_score = (alpha * matrice_HBN[j][j].performance_calcul) + ( beta * matrice_HBN[heuristique_courrant][j].performance_calcul) + ( gama * matrice_HBN[j][j].temps_attente);



        if(temp_score>max_score)
        {
            heuristique_de_bas_niveau = j;
            max_score=temp_score;
        }
    }


    return heuristique_de_bas_niveau;
}


/**********************************************/

void Hyper_Heuristic(void)
{

      timeval t1, t2;


    int i,j,l;
    float choisi_strategie;

    /****************/
   /*LARGE_INTEGER start, end, freq;*/

    double elapsedTime;

   double temps_execution_H_courrant;


    /****************/
   /*QueryPerformanceFrequency(&freq);*/

    liste_HBN[0] = heuristic_H1;
    liste_HBN[1] = heuristic_H2;
    liste_HBN[2] = heuristic_H3;
    liste_HBN[3] = heuristic_H4;
    liste_HBN[4] = heuristic_H5;
    liste_HBN[5] = heuristic_H6;
    liste_HBN[6] = heuristic_H7;

    // Initialisation de la matrice des HBN.

    for(i=0; i<nb_HBN; i++)

        for(j=0;j<nb_HBN;j++)
        {
            matrice_HBN[i][j].temps_attente=0.0;
            matrice_HBN[i][j].performance_calcul=0.0;
        }


    init_sol(); // Initialiser la solution.

maxiter_begin=(double) clock();
maxiter_now=(double) clock();


while(((double)(maxiter_now-maxiter_begin)/CLOCKS_PER_SEC)<180.0 && best_c_cour<m1)//for(i=0; i<max_iter;i++)
    {

     //heuristique_courrant=rand()%nb_HBN;

      choisi_strategie=rand()/(float)RAND_MAX;

        if(choisi_strategie < 0.4)


heuristique_courrant=rand()%nb_HBN; //0.0105 donne de bon r�ultat plus ou moins.

  else   heuristique_courrant=Choisir_Heuristique(i);


 // Fonction permettant de selectionn�l'heuristique ayant le score le plus grand
        matrice_HBN[heuristique_courrant][heuristique_courrant].temps_attente = 0.0;
        // Enregistrer le temps actuel pour pouvoir l'utiliser lors du calcule du temps qu'�pris cette heuristique lors du traitment.


    /****************/
  /*QueryPerformanceCounter(&start);*/


        gettimeofday(&t1, NULL);   /*Linux*/


        // Lancer l'heuristique selectionn�
        liste_HBN[heuristique_courrant]();

        // Enregister le temps actuel, et puis soustraire avec le temps sauvegarder pr��ement, et la mettre dans la variable "temps_execution_H_courrant"



  /*QueryPerformanceCounter(&end);*/

    /****************/

   gettimeofday(&t2, NULL);  /*Linux*/

elapsedTime = (double)(t2.tv_sec - t1.tv_sec) * NANO_S + (double)(t2.tv_nsec - t1.tv_nsec); // get elapsed time in ns


    /*elapsedTime = (t2.tv_sec - t1.tv_sec) * 1000.0;*/
   /*elapsedTime += (t2.tv_usec - t1.tv_usec) / 1000.0;*/
    
 


        /*temps_execution_H_courrant = (NANO_S * (end.QuadPart - start.QuadPart))/freq.QuadPart;*/ 

temps_execution_H_courrant = elapsedTime;

        if(temps_execution_H_courrant==0.0) temps_execution_H_courrant=0.000001;

        // Enregister les performances de l'heuristique dans la matrice, ainsi que le temps d'attente des autres heuristique.
        // Calcul f3
        for(j=0; j<nb_HBN;j++) // Ceci calcul le temps d'attente des heuristiques.
            if(heuristique_courrant!=j) {matrice_HBN[j][j].temps_attente = matrice_HBN[j][j].temps_attente + temps_execution_H_courrant;} //printf("\n temps attente H%d = %f\n",j,matrice_HBN[j][j].temps_attente);}
        // Calcul de f1
        matrice_HBN[heuristique_courrant][heuristique_courrant].performance_calcul= (alpha * matrice_HBN[heuristique_courrant][heuristique_courrant].performance_calcul) + ((double)(best_c_cour - c_cour)/(temps_execution_H_courrant));

        // Calcul de f2
        if(i!=0 && heuristique_courrant!=heuristique_precedent) // Ce n'est pas la premi�e heuristique �s'executer, et donc la fonction f2 sera calcul�
           matrice_HBN[heuristique_precedent][heuristique_courrant].performance_calcul=(beta*matrice_HBN[heuristique_precedent][heuristique_courrant].performance_calcul) + ((double)(best_c_cour - c_cour)/(temps_execution_H_courrant));

        // Puisque l'heuristique �termin�son execution, on l'affecte dans la variable "heuristique_precedent"
        heuristique_precedent = heuristique_courrant;

  //--------------------------- Methode d'acceptation de solution : //
        if(c_cour>best_c_cour)
        {

                for (l=0; l<n1; l++)
                {
                    best_soln[l]=sol[l];
                }
                best_c_cour=c_cour;
            }

    maxiter_now=(double) clock();
    }

}





/************************************************/

int main (int argc, char* argv[])
{

 static double last_clock;
 static double now_time;
 int j, var;
 data_p p;


 int i, l, FK;
 data_p p1, p2;
 double SS, SS1;

printf("\n C ---------------------------------------------------------- \n");
 
printf("\n C      This is an Incomplete solver for MAX-SAT, version 1.0 \n ");

printf("\n C ---------------------------------------------------------- \n");
 



/*printf(" The Maximum number of iterations : "); scanf("%d", &max_iter);*/

 /*printf(" The Walk probability : "); scanf("%f", &WP);*/

if(argc!=2) printf("Please, give the name of the input file");
else {
    filo=argv[1];

/*if ((f_out = fopen(SORTIE,"w")) == NULL)
    {
      fprintf(stderr, "\nErreur: Impossible d'ecrire dans le fichier %s\n",SORTIE);
      return(EXIT_FAILURE);
    }



     fputs("\n ",f_out);
 fputs(" Instance   #Vars  #Cl    #Unsat    Time  ",f_out);*/



   
         best_best_c_cour=0;
         best_c_cour=0;
         c_cour=0;

	   read_prob(filo);

         last_clock = (double) clock ();
         best_c_cour=0;
         seed = 1;
         srand(seed);



        Hyper_Heuristic();


        now_time = (double) clock ();

  /*printf (" \n The BANCHMARK is  "); printf ("%s", filo);
  printf (" \n The Number of variables is :    ");  printf ("%d", n1);
  printf (" \n The Number of clauses is :    ");  printf ("%d", m1);*/
  printf(" \n C The CPU time is %2.10f \n", (double) (now_time - last_clock) / CLOCKS_PER_SEC);
  /*printf(" \n The number of SAT Clauses   %d ", best_c_cour);*/
  printf(" \n S The number of UNSAT Clauses is  %d \n ", m1- best_c_cour );
  
printf("\n V Best Solution found is ------------------------------------------------- \n");
  
for(i=0;i<n1;i++) {
             if (best_soln[i]==1) {printf ("%5d", i+1);}
               else {printf ("%5d", -(i+1));}
                  }


printf("\n V The interpretation (0--> False, 1-->True: ----------------------------- \n");
  
for(i=0;i<n1;i++) {
              printf ("%5d", best_soln[i]);
             
                  }

printf("\n C ---------------------------------------------------------- \n");




/*best_c_cour = 0;
     for (j = 0; j < m1; j++)
     {
	  p = clauses[j];
	  sat_count[j] = 0;
	  while (p != ((data_p) NULL)) {
	       var = p->n;
	       if (best_soln[var] == 1) {
		    if (p->sense == 1) {
			 sat_count[j] = sat_count[j] + 1;
		    };
	       } else {
		    if (p->sense == 0) {
			 sat_count[j] = sat_count[j] + 1;
		    };
	       };
	       p = p->next2;
	  };
	  if (sat_count[j] > 0)
        {
	       best_c_cour++;
	    };
     }

     printf("best_c_cour = %d",best_c_cour);*/

        /*fputs(" \n",f_out);
 
       fputs(filo, f_out);
        fprintf(f_out, "( %d / %d )& %d & %7.6f ",n1,m1, m1-best_c_cour, (double) (now_time - last_clock) / CLOCKS_PER_SEC);
        fputs(" ",f_out);


          for(i=0; i<n1;i++)
          {
           p1= vars[i];
           while (p1->next1 != (data_p) NULL)
                 {
                  p2= p1;
                  p1= p1->next1;
                  free(p2);
                  }
          }



   
   fclose(f_out);*/

 }
   return 0;
 }



